<?php //
// crontab:
// */5 * * * *  root bash -c "sleep 5;cd /var/www/archiv/;php idana-import.php >>/var/log/idana-import.log 2>&1"
// mkdir /var/samba/trp/C/idana-pdf; mkdir /var/samba/trp/C/idana-pdf-done;
//$t = 120;
//ini_set("max_execution_time", $t);
set_time_limit(120); // Script timeout in seconds, need some high value for LibreOffice etc
include("engine.php");
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
$EnableUTF8 = false;

if ($EnableUTF8) {
	header('Content-Type: application/json; charset=utf-8');
}

////$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)
//$gdata = $_GET; // Parameters
$gdata = [];
$gdata["Action"] = "Idana";

$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $gdata["Action"]; // returns the Action/ Action code, same as request
$ret["data"] = ""; // contains payload/ return data
$ret["message"] = ""; // contains error message, if any

$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)

if ($EnableUTF8) {
	$jdata = deutf8ize($jdata);
}

/*if (isset($_GET["wsid"])) {
	$wsid = $_GET["wsid"];
}
if (isset($jdata["wsid"])) {
	$wsid = $jdata["wsid"];
}*/


// Response to store file information to database.
if ($gdata["Action"] == "Idana") {
	//$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)
	//$filepath = join(DIRECTORY_SEPARATOR, array($jdata["Directory"], $jdata["Filename"]));
	//$Directory = $jdata["Directory"];
	//$uploaddir = str_replace("/", DIRECTORY_SEPARATOR, $Directory);
	$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $archivuploadlocation));

	//$patNr = intval($jdata["patNr"]);
	//$DateOverride = $jdata["DateOverride"];
	//$ClassificationOverride = $jdata["ClassificationOverride"];
	//$RemarkOverride = $jdata["RemarkOverride"];
	$datUser = date("Y-m-d H:i:s");

	//$docFileName = $file_name_noext . $DefaultDocName . "." . $file_ext;

	//$fromToName = $jdata["From"];
	//$fromTo = $DefaultfromTo;
	$discipl = "idana";
	$arch = intval($jdata["Arch"]);

	//$rem5 = $jdata["Remark"];

	//$VonAn = $jdata["VonAn"];
	//$DokType = $jdata["DokType"];

	$idanasrcdir = str_replace("\\", "/", $idanaImportSourcePath);
	$srcpathelements = explode("/", $idanasrcdir);
	$idanadstdir = str_replace("\\", "/", $idanaImportDestinationPath);
	$dstpathelements = explode("/", $idanadstdir);

	$srcdirpathcomplete = join(DIRECTORY_SEPARATOR, $srcpathelements);
	$dstdirpathcomplete = join(DIRECTORY_SEPARATOR, $dstpathelements);


	$SuccessfulFiles = [];
	$FailedFiles = [];
	echo "\n";
	echo date("Y-m-d H:i:s") . "\n";
	echo "Scanning..." . $srcdirpathcomplete . "   <br />\n";
	$sdir = scandir($srcdirpathcomplete);
	$files = [];
	foreach ($sdir as $s) {
		$patharr = $srcpathelements;
		array_push($patharr, $s);
		$spath = join(DIRECTORY_SEPARATOR, $patharr);
		if (!is_dir($spath)) {
			$arr = [];
			$arr["Filename"] = $s;
			array_push($files, $arr);
		}
	}
	echo count($files) . " files found." . "   <br />\n\n";



	try {
	    $conn = DBOpenConnection();
	    $res["status"] = true;
		foreach ($files as $fil)
		{
			$File = [];
			$filename = $fil["Filename"];
			$File["Filename"] = $filename;
			$patharr = $srcpathelements;
			array_push($patharr, $filename);
			$filepath = join(DIRECTORY_SEPARATOR, $patharr);
			$filevalid = false;
			$FieldType = "";
			$FileFields = [];
			$patNr = 0;
			$expfilename = explode("_", $filename);
			if (count($expfilename) >= 4) {
				$filevalid = true;
			}
			if ($filevalid) { // extract fields
				$fieldvalid = false;
				for ($i = 0; $i < count($expfilename); ++$i)
				{
					if ($i <= 3) {
						$FileFields[$i] = $expfilename[$i];
					} else { // append all the "-" separated fields to last field (remark)
						$FileFields[3] .= $expfilename[$i];
					}
				}
				// Remove extension from the last field
				$exp = explode(".", $FileFields[3]);
				if (count($exp) > 1) {
					$FileFields[3] = "";
					for($i = 0; $i < (count($exp)-1); ++$i) {
						$FileFields[3] .= $exp[$i];
					}
				}

				// Determine field type
				if (strlen($FileFields[0]) > 0) {
					if (substr($FileFields[0], 0, 1) == "i") {
						$FieldType = "i";
						$filevalid = true;
					}
				}
				if ((!$fieldvalid) && (strlen($FileFields[0]) >= 3)) {
					if (substr($FileFields[0], 0, 3) == "ext") {
						$FieldType = "ext";
						$filevalid = true;
					}
				}
				if ((!$fieldvalid) && (is_numeric($FileFields[0]))) {
					$FieldType = "patNr";
					$patNr = intval($FileFields[0]);
					$filevalid = true;
				}
			}
			$File["Fields"] = $FileFields;
			$File["Type"] = $FieldType;
			if ($filevalid) {
				$pvalid = false;
				if ($FieldType == "patNr") {
					if ($patNr > 0) {
					 	/*try {
							//$conn = DBOpenConnection();
							$sql = "SELECT * FROM patimport WHERE patNrP = :patNr";
							$stmt = $conn->prepare($sql);
							$stmt->bindValue(':patNr', $patNr, PDO::PARAM_INT);

							$stmt->execute(); // true or false
							$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

							$res = $stmt->fetchAll();
							if (!$res) {
								$ret["status"] = false;
								$ret["message"] = "Patient not found in patimport. patNr: " . $patNr;
							} else {
								// patient found
								$pvalid = true;
							}
						}
						catch(PDOException $e) {
						    $ret["status"] = false;
						    $ret["message"] = $e->getMessage();
						}
						//$conn = null;
						*/
					} else {
						$patNr = 0;
						$pvalid = true;
						$arch = 0;
					}
				}

				//$patNr = intval($jdata["patNr"]); // set above
				//$DateOverride = $jdata["DateOverride"];
				//$ClassificationOverride = $jdata["ClassificationOverride"];
				//$RemarkOverride = $jdata["RemarkOverride"];
				$datUser = date("Y-m-d");
				$dateIn = date("Y-m-d H:i:s");

				$docFileName = $filename;
				$File["DestinationFilename"] = $filename;

				$fromToName = $FileFields[1];
				$fromTo = $DefaultfromTo;
				$discipl = "idana";
				$arch = 0;
				$rem5 = $FileFields[3]. "," . $FileFields[0];
				$DokType = "PDF";
				$dtypUser = "PDF";

				/*if (trim($datUser) == "") {
					$datUser = $Nowed;
				} else {
					$tmpdate = new DateTime($datUser);
					$tmpdate = $tmpdate->format("Y-m-d");
					if ($tmpdate == date("Y-m-d")) {
						$datUser = $Nowed;
					}
				}*/
				$sqldate = $Nowed;
				/*$sqldate = new DateTime($datUser);
				$sqldate = $sqldate->format("Y-m-d");
				$datUser = $sqldate;
				$sqldatetime = new DateTime($dateIn);
				$sqldatetime = $sqldatetime->format("Y-m-d H:i:s");
				$dateIn = $sqldatetime;*/

				$filenamed = str_replace(" ", "", $filename);
				$exp = explode(".", $filenamed);
				$file_ext = "";
				$file_name_noext = $exp[0];
				if (count($exp) > 0) {
					$file_ext = strtolower(end($exp));
					$file_name_noext = "";
					for($j=0; $j<(count($exp)-1); $j++) {
						if ($file_name_noext != "") {
							$file_name_noext = $file_name_noext . ".";
						}
						$file_name_noext = $file_name_noext . $exp[$j];
					}
				}

				$i = 0;
				$found = true;
				while($found == true) {
					$found = false;
					$fils = scandir($uploaddircomplete);
					foreach($fils as $fil) {
						$dexp = explode(".", $fil);
						$dname = "";
						if (count($dexp) == 1) {
							$dname = $fil;
						} else {
							for($j=0; $j<(count($dexp)-1); $j++) {
								if ($dname != "") {
									$dname = $dname . ".";
								}
								$dname = $dname . $dexp[$j];
							}
						}
						if ($file_name_noext == $dname) {
							$found == true;
							$i = $i + 1;
							$file_name_noext = $file_name_noext . "_" . $i;
						}
					}
				}
				$docFileName = $file_name_noext . "." . $file_ext;

				$patharr = $srcpathelements;
				array_push($patharr, $filename);
			    $srcpathcomplete = join(DIRECTORY_SEPARATOR, $patharr);
			    $patharr = $dstpathelements;
				array_push($patharr, $docFileName);
			    $dstpathcomplete = join(DIRECTORY_SEPARATOR, $patharr);

			    $uploadpathcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $archivuploadlocation, $docFileName));

				if (file_exists($srcpathcomplete)) {
					$stmt = $conn->prepare("INSERT INTO doarch (patNr, dateIn, datUser, dtype, dtypUser, fromTo, fromToName, discipl, docFileName, archMFP, archA1, archA2, archA3, archA4, archA5, archA6, archFirst, rem5) VALUES (:patNr, :dateIn, :datUser, :dtype, :dtypUser, :fromTo, :fromToName, :discipl, :docFileName, :archMFP, :archA1, :archA2, :archA3, :archA4, :archA5, :archA6, :archFirst, :rem5)");
				    $stmt->bindValue(':patNr', $patNr, PDO::PARAM_INT);
				    $stmt->bindValue(':dateIn', $dateIn, PDO::PARAM_STR); // timestamp
				    $stmt->bindValue(':datUser', $datUser, PDO::PARAM_STR); // timestamp
				    $stmt->bindValue(':dtype', $Defaultdtype, PDO::PARAM_STR);
				    $stmt->bindValue(':dtypUser', $dtypUser, PDO::PARAM_STR);
				    $stmt->bindValue(':fromTo', $fromTo, PDO::PARAM_STR);
				    $stmt->bindValue(':fromToName', $fromToName, PDO::PARAM_STR);
				    $stmt->bindValue(':discipl', $discipl, PDO::PARAM_STR);
				    $stmt->bindValue(':docFileName', $docFileName, PDO::PARAM_STR);
				    $stmt->bindValue(':archMFP', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA1', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA2', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA3', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA4', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA5', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archA6', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':archFirst', $arch, PDO::PARAM_INT);
				    $stmt->bindValue(':rem5', $rem5, PDO::PARAM_STR);
					$r = $stmt->execute(); // true or false

					echo "Src: " . $File["Filename"] . "   <br />\n";
					echo "Dst: " . $File["DestinationFilename"] . "\t" . "Successful.   <br />\n";

				    if ($r) {
					    // Save file time
						$tmptime = filemtime($srcpathcomplete);
						copy($srcpathcomplete, $uploadpathcomplete);
						rename($srcpathcomplete, $dstpathcomplete);
						touch($dstpathcomplete, $tmptime);
					    array_push($SuccessfulFiles, $File);
			    	} else {
				    	echo "File: " . $File["Filename"] . "\t" . "Failed (db).<br />\n";
				    	array_push($FailedFiles, $File);
						$res["status"] = false;
						$res["message"] = "\$stmt->execute() returned false<br /><br />Some entries could not be saved";
					}
				} // if (file_exists())
			} else { // if ($filevalid)
				echo "File: " . $File["Filename"] . "\t" . "Failed (Filename).<br />\n";
				array_push($FailedFiles, $File);
			}
		} // end foreach ($files as $file)
	}
	catch(PDOException $e) {
	    $res["status"] = false;
	    echo $e->getMessage();
	    $res["message"] = $e->getMessage();
	}
	$conn = null;
	$rdata["SuccessfulFiles"] = $SuccessfulFiles;
	$rdata["FailedFiles"] = $FailedFiles;

	if ($res["status"] != false) {
		$ret["status"] = true;
		$ret["message"] = " files saved successfully.";
	}
	$ret["data"] = $rdata;
}



if ($EnableUTF8) {
	//echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
} else {
	//echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
}

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = deutf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}


/**
 * Generate a random string, using a cryptographically secure
 * pseudorandom number generator (random_int)
 *
 * For PHP 7, random_int is a PHP core function
 * For PHP 5.x, depends on https://github.com/paragonie/random_compat
 *
 * @param int $length      How many characters do we want?
 * @param string $keyspace A string of all possible characters
 *                         to select from
 * @return string
 */
function random_str_old(
    $length,
    $keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
    //`~!@#$%^&*()-_+=\|/?[{}]<,>.
    //!#%&*()-+=?<,>.
) {
    $str = '';
    //$max = mb_strlen($keyspace, '8bit') - 1;
    $max = strlen($keyspace) - 1;
    if ($max < 1) {
        throw new Exception('$keyspace must be at least two characters long');
    }
    for ($i = 0; $i < $length; ++$i) {
        $str .= $keyspace[random_int(0, $max)];
    }
    // aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
    //   You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
    //                     2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
    //   Or do you have better idea to reach the aim faster?
    return $str;
}


function random_str(
    $length
) {
	$keys = [];
	$keys[0] = [];
	$keys[0]["keyspace"] = "123456789";   // not use 0 <-> O
	$keys[0]["mincount"] = 1; // how many to include
	$keys[0]["maxcount"] = 1; // how many to include
	$keys[1] = [];
	$keys[1]["keyspace"] = "abcdefghijklmnopqrstuvwxyz";
	$keys[1]["mincount"] = 1; // how many to include
	$keys[1]["maxcount"] = 1; // how many to include
	$keys[2] = [];
	$keys[2]["keyspace"] = "ABCDEFGHIJKLMNPQRSTUVWXYZ"; // not use O <-> 0
	$keys[2]["mincount"] = 1; // how many to include
	$keys[2]["maxcount"] = 1; // how many to include
	$keys[3] = [];
	$keys[3]["keyspace"] = "!#%*-+=?,[."; // & ( ) < > ] / \ better not use
	$keys[3]["mincount"] = 1; // how many to include
	$keys[3]["maxcount"] = 1; // how many to include

    $str = '';

    $c = 0;
    while (strlen($str) < $length)
    {
	    for ($i = 0; $i < count($keys); ++$i)
	    {
	        //$max = mb_strlen($keyspace, '8bit') - 1;
		    $max = strlen($keys[$i]["keyspace"]); - 1;
		    if ($max < 1) {
		        throw new Exception('$keyspace must be at least two characters long');
		    }
		    $str .= $keys[$i]["keyspace"][random_int(0, $max)];
	    }
	}
	$str = substr($str, 0, $length);
	shuffle($str);
    /*for ($i = 0; $i < $length; ++$i) {
        $str .= $keyspace[random_int(0, $max)];
    }*/
    // aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
    //   You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
    //                     2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
    //   Or do you have better idea to reach the aim faster?
    return $str;
}


function removedirs($directory) {
	$dirs = scandir($directory);
	foreach($dirs as $dir) {
		$d = join(DIRECTORY_SEPARATOR, array($directory, $dir));
		if ((trim($dir) != ".") && (trim($dir) != "..") && (is_dir(trim($d)))) {
			if (DIRECTORY_SEPARATOR == "\\") {
				$ex = "rmdir /S /Q \"" . trim($d) . "\"";
			} else {
				$ex = "rm -rf \"" . trim($d) . "\"";
			}
			exec($ex, $output, $r);
			/*if ($r) {
				echo $ex . "\n";
				print_r($output);
				echo "Return code: " . $r . "\n";
			}*/
		}
	}
}


// cleans contact number (telephone, fax) from non-numeric characters
function cleancontactnumber($number) {
	$remchars = [" ", "-", "/", ".", ","];
	foreach ($remchars as $ch)
	{
		$number = str_replace($ch, "", $number);
	}
	return $number;
}

function subst_specialchars_filenames($text) {
    $specialchars=array("!","|","#","*","<",">"," ", "'",",", "/", "\\", "\"", "\:","°",".","`","^");
    $ret=str_replace($specialchars,"_",$text);
    return $ret;
    }

function limittext($text, $length) {
	$ret = $text;
	if (strlen($text) > $length)
	{
		$ret = substr($ret, 0, $length);
	}
	return $ret;
}

function mbStringToArray ($string) {
    $strlen = mb_strlen($string);
    while ($strlen) {
        $array[] = mb_substr($string,0,1,"UTF-8");
        $string = mb_substr($string,1,$strlen,"UTF-8");
        $strlen = mb_strlen($string);
    }
    return $array;
}
?>
